package math;

public class Calculator implements Visitor {

	private Context context;

	private int total;

	public Calculator(Context context) {
		this.context = context;
		this.total = 0;
	}

	public void visit(TerminalExpression te) {
		total = te.evaluate(context);
	}

	public void visit(SubtractExpression se) {
		int result;
		se.getLeftNode().accept(this);
		result = total;
		se.getRightNode().accept(this);
		result -= total;
		total = result;
	}

	public void visit(AddExpression ae) {
		int result;
		ae.getLeftNode().accept(this);
		result = total;
		ae.getRightNode().accept(this);
		result += total;
		total = result;
	}

	public void visit(MultiplyExpression me) {
		int result;
		me.getLeftNode().accept(this);
		result = total;
		me.getRightNode().accept(this);
		result *= total;
		total = result;
	}

	public int getTotal() {
		return this.total;
	}

}
